/* This module "scores" the survy. It goes through each question of the
 * survey, gets the value of the checked radio button and totals a score for
 * that section. It then make visible the appropriate response for the
 * section. BK - 2017-03-06
 */

var SurveyScorer = (function() {

    var TOTAL_QUESTIONS = 29

    var expectations = {questions:["e1", "e2", "e3"]};
    var selfdirection = {questions:["sd1", "sd2", "sd3","sd4"]};
    var learningpreferences = {questions: ["lp1", "lp2","lp3","lp4","lp5"]};
    var studyhabits = {questions: ["sh1","sh2","sh3","sh4","sh5","sh6","sh7"]};
    var technicalskills = {questions: ["ts1","ts2","ts3","ts4"]};
    var technicalrequirements = {questions: ["tr1","tr2","tr3","tr4","tr5","tr6"]};
    var sections = [expectations, selfdirection, learningpreferences, studyhabits, technicalskills, technicalrequirements]


    function checkAllSelected() {
        if ( document.querySelectorAll('input:checked').length != TOTAL_QUESTIONS ) {
            alert("Please answer all the questions on the survey in order to get the best results. Thank-you!");
        } 
        else {
           return true
        }
    }

    function calculateScore(section) {
        var section_score = 0;
        for ( var i=0; i < section.questions.length; i++ ) {
            var input_name = section.questions[i]; 
            var query_string = "input[name=\"" + input_name + "\"]:checked"
            section_score += +document.querySelector(query_string).value;
        }
        return section_score
    }

    function toggleResultFeedback(id, state){
        if (state == "hide") {
            document.getElementById(id).classList.add("hidden");
        }
        else {
            document.getElementById(id).classList.remove("hidden");
        }
    }

    function displayLogic() {
        for ( var i=0; i < sections.length; i++ ) {
            var section = sections[i];
            var score = calculateScore(section);

            // positive scores are already set to display
            // so you only need to toggle on low scores
            if ( section == expectations && score < 6 ){
                toggleResultFeedback("e-pos", "hide");
                toggleResultFeedback("e-neg", "show");
            }
            else if ( section == selfdirection && score < 8 ){
                toggleResultFeedback("sd-pos", "hide");
                toggleResultFeedback("sd-neg", "show");
                
            }
            else if ( section == learningpreferences && score < 10 ){
                toggleResultFeedback("lp-pos", "hide");
                toggleResultFeedback("lp-neg", "show");
            }
            else if ( section == studyhabits && score < 14 ){
                toggleResultFeedback("sh-pos", "hide");
                toggleResultFeedback("sh-neg", "show");
            }
            else if ( section == technicalskills && score < 8 ){
                toggleResultFeedback("ts-pos", "hide");
                toggleResultFeedback("ts-neg", "show");
               
            }
            else if ( section == technicalrequirements && score < 12 ){
                toggleResultFeedback("tr-pos", "hide");
                toggleResultFeedback("tr-neg", "show");
            }
       }
    }

    function showResults() {
        displayLogic();
        document.getElementById("results").classList.remove("hidden");
        document.getElementById("results").scrollIntoView();
    }


    return {
        main: function() {
            if ( checkAllSelected() ) {
                showResults();
            }
        } 
    }
})();
